#include "includes.h"

struct ping_conf ping_con;

static u16 ping_id = 0x0001;

#define ICMPBUF ((struct uip_icmpip_hdr *)&uip_buf[UIP_LLH_LEN])
int ping_handle(int data)
{
	u8 *ip;
	struct ping_conf *ping_con = (struct ping_conf *)data;
	ip = (u8*)ping_con->dstipaddr;

	if(ICMPBUF->seqno == htons((ping_con->seq-1)))
		debug_printf("%d bytes from %d.%d.%d.%d: icmp_req=%d ttl=%d time<%d ms\n",uip_len-UIP_IPH_LEN,
				ip[0],ip[1],ip[2],ip[3],ping_con->seq-1,ICMPBUF->ttl, (ticks-ping_con->timer+1)*10);
//	ping_stop();
	return 0;

}

void ping_start2(u16 dstipaddr[2], u16 datalen, u32 time, u32 maxnum, void *handle)
{
	ping_con.maxnum = maxnum;
	ping_con.interval_time = time/10;
	memcpy(ping_con.dstipaddr,dstipaddr,4);
	ping_con.dlen = datalen;
	ping_con.handle = handle;
	ping_con.timer = ticks;
	ping_con.seq = 0;
	if(ping_id==0)
		ping_id++;
	ping_con.id = ping_id++;
}
void ping_start(u16 dstipaddr[2],void *handle)
{
	ping_start2(dstipaddr, 56, 1000, 0xffffffff, handle);
}
void ping_stop(void)
{
	memset(&ping_con,0, sizeof(ping_con));
}

